# -*- coding: UTF-8 -*-

from tkinter import *
from tkinter import ttk
from tkinter import filedialog
from tkinter import messagebox
import os.path
import sys


def commandDo():
    messagebox.showinfo(message='Pas encore implémenté')

def populateFromLeft():
    idxs = lboxg.curselection()
    l = lboxm.size()
    for i in idxs:
        if (l == 256):
            messagebox.showerror(message='256 Arpèges maximum')
            break
        s = lboxg.get(i)
        ns = '%03d >%s' %(l, s)
        lboxm.insert(END, ns)
        l += 1
        if newFileName != '':
            bmm['state'] = 'enabled'
    l = lboxm.size()
    lfm['text'] = '%d Arpèges' % l

def populateFromRight():
    idxs = lboxd.curselection()
    l = lboxm.size()
    for i in idxs:
        if (l == 256):
            messagebox.showerror(message='256 Arpèges maximum')
            break
        s = lboxd.get(i)
        ns = '%03d <%s' %(l, s)
        lboxm.insert(END, ns)
        l += 1
        if newFileName != '':
            bmm['state'] = 'enabled'
    l = lboxm.size()
    lfm['text'] = '%d Arpèges' % l


def clearMid():
    lboxm.delete(0, END)
    lfm['text'] = '0 Arpège'
    bmm['state'] = 'disabled'

def removeLast():
    lboxm.delete(END, END)
    l = lboxm.size()
    lfm['text'] = '%d Arpèges' % l
    if l == 0:
        bmm['state'] = 'disabled'

def openFileLeft():
    filename = filedialog.askopenfilename(initialdir= 'D:\Yamaha\Cle64GO\BACKUPS\PATARP', filetypes = [("MOXF Arpèges", "*.X6A;*.X6G")])
    if filename != '':
        (filepath, name) = os.path.split(filename)
        (shortname, extension) = os.path.splitext(name)
        lfhg['text'] = name
        ficLeft['stat'] = 'enabled'
        ficLeft.delete(0, END)
        ficLeft.insert(0, filename)
        ficLeft['stat'] = 'readonly'
        readFicGauche(filename)

def openFileMid():
    global newFileName
    filename = filedialog.asksaveasfilename(initialdir= 'D:\Yamaha\Cle64GO\BACKUPS\PATARP', filetypes = [("MOXF Arpèges", "*.X6G")], defaultextension='.X6G', confirmoverwrite=False)
    if filename != '':
        (filepath, name) = os.path.split(filename)
        (shortname, extension) = os.path.splitext(name)
        lfhm['text'] = name
        ficMid['stat'] = 'enabled'
        ficMid.delete(0, END)
        ficMid.insert(0, filename)
        ficMid['stat'] = 'readonly'
        newFileName = filename
        if lboxm.size() != 0:
            bmm['state'] = 'enabled'

def openFileRight():
    filename = filedialog.askopenfilename(initialdir= 'D:\Yamaha\Cle64GO\BACKUPS\PATARP', filetypes = [("MOXF Arpèges", "*.X6A;*.X6G")])
    if filename != '':
        (filepath, name) = os.path.split(filename)
        (shortname, extension) = os.path.splitext(name)
        lfhd['text'] = name
        ficRight['stat'] = 'enabled'
        ficRight.delete(0, END)
        ficRight.insert(0, filename)
        ficRight['stat'] = 'readonly'
        readFicDroit(filename)

def bg(bigendian):
    bg = int(bigendian[3]) + int(bigendian[2]) * 0x100 + int(bigendian[1]) * 0x10000 + int(bigendian[0]) * 0x1000000
    return bg

def findOffsetDARP(datas):
    version = datas[0x10:0x10+5]
    if version != b'1.0.3' and version != b'1.0.4':
        messagebox.showerror(message = 'Version du fichier non supportée (%s)'% version.decode())
        root.destroy()
    lenCatalogue = bg(datas[0x20:0x20+4])
    catalogue = datas[0x40:0x40+lenCatalogue]
    cursor = 0
    trouve = False
    od = 0
    while cursor < lenCatalogue:
        if catalogue[cursor: cursor+4] == b'DARP':
            trouve = True
            od = bg(catalogue[cursor+4:cursor+8])
        cursor += 8
    if trouve == False:
        messagebox.showerror(message = 'Entree Catalogue DARP non trouvée.')
        root.destroy()
    return od

def litDirArp(datas, od):
    offsetfin = bg(datas[od+4:od+8])
    delta = 256*8
    offsetdebut = offsetfin - delta
    cursor = od + 8 + offsetdebut
    arpdir = []
    for i in range(256):
        offsetArp = bg(datas[cursor: cursor+4])
        lenArp = bg(datas[cursor+4: cursor+8])
        cursor += 8
        if lenArp > 0 :
            arpdir.append([i, offsetArp, lenArp])
    return arpdir

def getDatasArp(datas, od, arpdir):
    datasarp = []
    for e in arpdir:
        offset = e[1]
        lenarp = e[2]
        datasarp.append(datas[od + 0x61C + offset : od + 0x61C + offset + lenarp])
    return datasarp

def getCategorie(n, datas, od):
    offset = od + 0x1C + (n * 6)
    categorie=[]
    for i in range(6):
        categorie.append(datas[offset+i])
    if categorie[0] != 0 or categorie[2] != 0:
        messagebox.showerror(message='Format Categorie inconnu.')
        root.destroy()
    return categorie

def getNom(arpdata):
    lenChunk1 = bg(arpdata[4:8])
    lenNom = lenChunk1 - 6
    nom = arpdata[4+4+6: 4+4+6+lenNom]
    return nom.decode()

def makeEmptyArps():
    s = b'YAMAHA-YSFC'
    s += b'\x00' * 5
    s += b'1.0.4'
    s += b'\x00' * 14
    s += b'\x10'
    s += b'\xff' * 28
    s += b'EARP\x00\x00\x00PDARP\x00\x00\x00\x85'
    s += b'\x45\x41\x52\x50\x00\x00\x00\x2d\x00\x00\x00\x01\x45\x6e\x74\x72'
    s += b'\x00\x00\x00\x21\x00\x10\x0e\x08\x00\x00\x00\x0c\x00\x00\x00\x00'
    s += b'\x55\x73\x65\x72\x20\x41\x72\x70\x65\x67\x67\x69\x6f\x20\x20\x20'
    s += b'\x20\x20\x20\x20\x00\x44\x41\x52\x50\x00\x10\x0e\x14\x00\x00\x00'
    s += b'\x01\x44\x61\x74\x61\x00\x10\x0e\x08\x0d\xa9\x76\xe0\x00\x00\x01\x00'
    for i in range(256):
        s += i.to_bytes(2, 'big')
        s += i.to_bytes(2, 'big')
        s += b'\xff\xff'
    s += b'\xff' * 1048576
    s += b'\x00' * 256 * 8
    return s

def findOffsetListChain(datas):
    offset = 0x6A1
    cursor = offset
    while cursor < 0x1006A1:
        if datas[cursor: cursor +4] == b'\xff\xff\xff\xff':
            return cursor
        delta = bg(datas[cursor+4: cursor+8])
        cursor += 8 + delta
    messagebox.showerror(message='Entree vide dans liste chainée non trouvée.')
    root.destroy()

def moveArp(datas, arpdir, datasarp, od, nfrom, nto, dto):
    dirarp = arpdir[nfrom]
    arpdata = datasarp[nfrom]
    categorie = getCategorie(dirarp[0], datas, od)
    nc = nto.to_bytes(2, 'big')
    nc += nto.to_bytes(2, 'big')
    nc += categorie[4].to_bytes(1, 'big')
    nc += categorie[5].to_bytes(1, 'big')
    offsetCat = 0xA1 + (nto * 6)
    dto[offsetCat: offsetCat + len(nc)] = nc
    offsetLC = findOffsetListChain(dto)
    dto[offsetLC: offsetLC + len(arpdata)] = arpdata
    offsetDir = 0x1006A1 + (nto * 8)
    offsetLCrelatif = offsetLC - 0x6A1
    dto[offsetDir: offsetDir+4] = offsetLCrelatif.to_bytes(4,'big')
    dto[offsetDir+4: offsetDir+8] = dirarp[2].to_bytes(4,'big')


def moveArps(listeMove, datas1, arpdir1, datasarp1, od1, datas2, arpdir2, datasarp2, od2, datas3, nbarp1, nbarp2):
    listeMerge = expandStringList(listeMove, nbarp1, nbarp2)
    for (i, e) in enumerate(listeMerge):
        if e[0] == 0:
            datas = datas1
            arpdir=arpdir1
            datasarp=datasarp1
            od=od1
        else:
            datas = datas2
            arpdir=arpdir2
            datasarp=datasarp2
            od=od2
        nfrom=e[1]-1
        nto= i
        dto = datas3
        moveArp(datas, arpdir, datasarp, od, nfrom, nto, dto)

def readFicGauche(filename):
    global datas1, arpdir1, datasarp1, od1, nbarp1
    datas1, arpdir1, datasarp1, od1, nbarp1 = readArpeges(filename)
    lboxg.delete(0, END)
    for x, e in enumerate(arpdir1):
        arpdata = datasarp1[x]
        nom = getNom(arpdata)
        categorie = getCategorie(e[0], datas1, od1)
        s = '%03d num:%03d Nom:%s.' % (x, e[0],  nom)
        lboxg.insert(END, s)
    lfg['text'] = '%d Arpèges' % nbarp1

def readFicDroit(filename):
    global datas2, arpdir2, datasarp2, od2, nbarp2
    datas2, arpdir2, datasarp2, od2, nbarp2 = readArpeges(filename)
    lboxd.delete(0, END)
    for x, e in enumerate(arpdir2):
        arpdata = datasarp2[x]
        nom = getNom(arpdata)
        categorie = getCategorie(e[0], datas2, od2)
        s = '%03d num:%03d Nom:%s.' % (x, e[0],  nom)
        lboxd.insert(END, s)
    lfd['text'] = '%d Arpèges' % nbarp2

def readArpeges(filename):
    file = open(filename,mode='rb')
    datas = file.read()
    file.close()
    od = findOffsetDARP(datas)
    arpdir = litDirArp(datas, od)
    nbarp = len(arpdir)
    datasarp = getDatasArp(datas, od, arpdir)
    return datas, arpdir, datasarp, od, nbarp

def expandStringList(s, maxLeft, maxRight):
    listeMerge = []
    t = s.split(',')
    for e in t:
        x = e.find('..')
        if x >= 0:
            iliste = ord(e[0]) - ord('a')
            if not(-1 < iliste < 2):
                messagebox.showerror(message='Lettre de liste invalide.')
                root.destroy()
            imin = int(e[1:x])
            imax = int(e[x+2:])
            lmax = maxLeft if iliste == 0 else maxRight
            if imin > lmax or imin < 1 or imax > lmax or imax < 1 or imax < imin:
                messagebox.showerror(message="Numéro d'arpège invalide.")
                root.destroy()
            for i in range(imin, imax+1):
                listeMerge.append([iliste, i])
        else:
            iliste = ord(e[0]) - ord('a')
            if not(-1 < iliste < 2):
                messagebox.showerror(message='Lettre de liste invalide.')
                root.destroy()
            num = int(e[1:])
            lmax = maxLeft if iliste == 0 else maxRight
            if num > lmax or num < 1:
                messagebox.showerror(message="Numéro d'arpège invalide.")
                root.destroy()
            listeMerge.append([iliste, num])
    return listeMerge

def writeArp(nomOut, datas):
    ficOut = open(nomOut, 'wb')
    ficOut.write(datas)
    ficOut.close()

def prepareList():
    x = lboxm.size()
    l = ''
    for i in range(x):
        s = lboxm.get(i)
        c = 'a' if s[4] == '>' else 'b'
        n = str(int(s[13:16])+1)
        l += c + n
        if (i < x-1): l += ','
    return l

def createNewArpeges():
    l = prepareList()
    datas3 = bytearray(makeEmptyArps())
    moveArps(l, datas1, arpdir1, datasarp1, od1, datas2, arpdir2, datasarp2, od2, datas3, nbarp1, nbarp2)
    writeArp(newFileName, datas3)
    s = 'Le fichier %s a été ecrit.' % newFileName
    messagebox.showinfo(message=s)

root = Tk()

od1 =0
nbarp1 = 0
datas1 = []
arpdir1 = []
datasarp1 = []
od2 =0
nbarp2 = 0
datas2 = []
arpdir2 = []
datasarp2 = []
newFileName = ''

content = ttk.Frame(root, padding=(3,3,12,12))
root.title('MOXF Arpèges Mixeur')

lfg = ttk.Labelframe(content, text='0 Arpège')
lfm = ttk.Labelframe(content, text='0 Arpège')
lfd = ttk.Labelframe(content, text='0 Arpège')
lfhg = ttk.Labelframe(content, text='Fichier gauche')
lfhm = ttk.Labelframe(content, text='Fichier à créer')
lfhd = ttk.Labelframe(content, text='Fichier droit')

lboxg = Listbox(lfg)
lboxm = Listbox(lfm)
lboxd = Listbox(lfd)
lboxg['selectmode'] = EXTENDED
lboxd['selectmode'] = EXTENDED
slboxg = ttk.Scrollbar(lfg, orient=VERTICAL, command=lboxg.yview)
slboxm = ttk.Scrollbar(lfm, orient=VERTICAL, command=lboxm.yview)
slboxd = ttk.Scrollbar(lfd, orient=VERTICAL, command=lboxd.yview)
lboxg['yscrollcommand'] = slboxg.set
lboxm['yscrollcommand'] = slboxm.set
lboxd['yscrollcommand'] = slboxd.set
bll = ttk.Button(lfg, text = 'Liste', command= commandDo)
blm = ttk.Button(lfg, text = 'Info', command= commandDo)
bld = ttk.Button(lfg, text = '=>', command= populateFromLeft)
bml = ttk.Button(lfm, text = 'Efface tout', command= clearMid)
bmm = ttk.Button(lfm, text = 'Merge', command= createNewArpeges)
bmd = ttk.Button(lfm, text = 'Efface denier', command= removeLast)
bdl = ttk.Button(lfd, text = '<==', command= populateFromRight)
bdm = ttk.Button(lfd, text = 'Info', command= commandDo)
bdd = ttk.Button(lfd, text = 'Liste', command= commandDo)
status = ttk.Entry(content)
ficLeft = ttk.Entry(lfhg)
ficMid = ttk.Entry(lfhm)
ficRight = ttk.Entry(lfhd)
bhl = ttk.Button(lfhg, text = '...', command= openFileLeft)
bhm = ttk.Button(lfhm, text = '...', command= openFileMid)
bhr = ttk.Button(lfhd, text = '...', command= openFileRight)

lfhg.grid(column=0, row=0, sticky=(N, S, E, W), pady = 0, padx =5)
lfhm.grid(column=1, row=0, sticky=(N, S, E, W), pady = 0, padx =5)
lfhd.grid(column=2, row=0, sticky=(N, S, E, W), pady = 0, padx =5)
lfg.grid(column=0, row=1, sticky=(N, S, E, W), pady = 5, padx =5)
lfm.grid(column=1, row=1, sticky=(N, S, E, W), pady = 5, padx =5)
lfd.grid(column=2, row=1, sticky=(N, S, E, W), pady = 5, padx =5)
status.grid(column=0, row=2, columnspan = 3, sticky=(N, S, E, W), pady = 5, padx =5)

lboxg.grid(column=0, row=0, rowspan = 2, columnspan = 3, sticky=(N, S, E, W), pady = 5, padx =0)
lboxm.grid(column=0, row=0, rowspan = 2, columnspan = 3, sticky=(N, S, E, W), pady = 5, padx =0)
lboxd.grid(column=0, row=0, rowspan = 2, columnspan = 3, sticky=(N, S, E, W), pady = 5, padx =0)
slboxg.grid(column=3, row=0, sticky=(N, S), pady = 0, padx =0)
slboxm.grid(column=3, row=0, sticky=(N, S), pady = 0, padx =0)
slboxd.grid(column=3, row=0, sticky=(N, S), pady = 0, padx =0)
bll.grid(column=0, row=2,sticky=( W), pady = 5, padx =5)
blm.grid(column=1, row=2,sticky=( N), pady = 5, padx =5)
bld.grid(column=2, row=2,sticky=( E), pady = 5, padx =5)
bml.grid(column=0, row=2,sticky=( W), pady = 5, padx =5)
bmm.grid(column=1, row=2,sticky=( N), pady = 5, padx =5)
bmd.grid(column=2, row=2,sticky=( E), pady = 5, padx =5)
bdl.grid(column=0, row=2,sticky=( W), pady = 5, padx =5)
bdm.grid(column=1, row=2,sticky=( N), pady = 5, padx =5)
bdd.grid(column=2, row=2,sticky=( E), pady = 5, padx =5)

ficLeft.grid(column=0, row=0, columnspan = 2, sticky=(E,W), pady = 5, padx =0)
ficMid.grid(column=0, row=0, columnspan = 2, sticky=(E,W), pady = 5, padx =0)
ficRight.grid(column=0, row=0, columnspan = 2, sticky=(E,W), pady = 5, padx =0)
bhl.grid(column=2, row=0, sticky=(E,W), pady = 5, padx =0)
bhm.grid(column=2, row=0, sticky=(E,W), pady = 5, padx =0)
bhr.grid(column=2, row=0, sticky=(E,W), pady = 5, padx =0)

lfhg.columnconfigure(0, weight=5)
lfhg.columnconfigure(1, weight=5)
lfhm.columnconfigure(0, weight=5)
lfhm.columnconfigure(1, weight=5)
lfhd.columnconfigure(0, weight=5)
lfhd.columnconfigure(1, weight=5)

lfg.columnconfigure(0, weight=5)
lfg.columnconfigure(1, weight=5)
lfg.columnconfigure(2, weight=5)
lfg.rowconfigure(0, weight=1)
lfm.columnconfigure(0, weight=5)
lfm.columnconfigure(1, weight=5)
lfm.columnconfigure(2, weight=5)
lfm.rowconfigure(0, weight=1)
lfd.columnconfigure(0, weight=5)
lfd.columnconfigure(1, weight=5)
lfd.columnconfigure(2, weight=5)
lfd.rowconfigure(0, weight=1)


content.grid(column=0, row=0, sticky=(N, S, E, W))
root.columnconfigure(0, weight=1)
root.rowconfigure(0, weight=1)
content.columnconfigure(0, weight=3)
content.columnconfigure(1, weight=3)
content.columnconfigure(2, weight=3)
content.rowconfigure(1, weight=1)

bmm['state'] = DISABLED
ficMid['state'] = 'readonly'
ficRight['state'] = 'readonly'
ficLeft['state'] = 'readonly'


root.mainloop()
